;;; Ruby
(use-package inf-ruby
  :ensure t
  :config
  (add-hook 'ruby-mode-hook 'inf-ruby-minor-mode)
  (add-hook 'after-init-hook 'inf-ruby-switch-setup))

(use-package robe
  :ensure t
  :diminish robe-mode
  :config
  (add-hook 'ruby-mode-hook 'robe-mode))

(use-package rspec-mode
  :ensure t
  :diminish rspec-mode)

(use-package ruby-electric
  :ensure t)

(use-package yari
  :ensure t)

(use-package rbenv
  :ensure t
  :config
  (global-rbenv-mode))

(use-package haml-mode
  :ensure t)

(use-package scss-mode
  :ensure t)

(use-package less-css-mode
  :ensure t)

(use-package ruby-mode
  :ensure t
  :mode ("Gemfile\\'"
         "Gemfile\\.lock\\'"
         "Guardfile\\'"
         "Rakefile\\'"
         "\\.gemspec\\'"
         "\\.rabl\\'"))

(use-package rubocop
  :ensure t
  :config
  (add-hook 'ruby-mode-hook #'rubocop-mode))
